<?php
/*
Plugin Name: WatuPRO Social Sharing
Plugin URI: http://calendarscripts.info/watupro/bridges.html#share
Description: This plugin enables social sharing on quiz results (Currently Facebook)
Author: Kiboko Labs
Version: 0.7
Author URI: http://calendarscripts.info/
License: GPLv2 or later
*/

define( 'WATUPROSHARE_PATH', dirname( __FILE__ ) );
define( 'WATUPROSHARE_RELATIVE_PATH', dirname( plugin_basename( __FILE__ )));
define( 'WATUPROSHARE_URL', plugin_dir_url( __FILE__ ));

add_action('init', 'watuproshare_init');

function watuproshare_init() {
	global $wpdb;
	
	add_action('watupro_admin_menu', 'watuproshare_menu');
	add_action('wp_enqueue_scripts', 'watuproshare_enqueue');
	add_shortcode('watuproshare-buttons', 'watuproshare_display');	
}

function watuproshare_options() {
	global $wpdb;
	if(!empty($_POST['ok'])) {
		update_option('watuproshare_facebook_appid', $_POST['facebook_appid']);	
		$twitter_options = array("use_twitter" => @$_POST['use_twitter'], "show_count" => @$_POST['show_count'],
		 "via"=>$_POST['via'], "hashtag" => $_POST['hashtag'], 'large_button' => @$_POST['large_button'],
		 "tweet"=>$_POST['tweet']);
		update_option('watuproshare_twitter', $twitter_options);
	}
	
	$appid = get_option('watuproshare_facebook_appid');
	$twitter_options = get_option('watuproshare_twitter');
	include(WATUPROSHARE_PATH.'/views/options.html.php');
}

function watuproshare_menu() {
	add_submenu_page('watupro_exams', __("Social Sharing", 'watuproshare'), __('Social Sharing', 'watuproshare'), 
		'manage_options', 'watupro_social_share',  'watuproshare_options');
}

// enqueue the CSS
function watuproshare_enqueue() {
	 wp_enqueue_style(
			'watuproshare-style',
			WATUPROSHARE_URL.'css/main.css',
			array(),
			'0.5');
}

// display the social sharing buttons
function watuproshare_display() {
	global $wpdb;
	$taking_id = $GLOBALS['watupro_taking_id'];	
	ob_start();
	// https://developers.facebook.com/docs/sharing/reference/feed-dialog
	$appid = get_option('watuproshare_facebook_appid');
	
	// get the grade title and description
	$grade_id = $wpdb->get_var($wpdb->prepare("SELECT grade_id FROM ".WATUPRO_TAKEN_EXAMS." WHERE ID=%d", $taking_id));
	if(empty($grade_id)) $grade = (object)array("gtitle"=>'None', 'gdescription'=>'None');
	else $grade = $wpdb->get_row($wpdb->prepare("SELECT * FROM ".WATUPRO_GRADES." WHERE ID=%d", $grade_id));
	
	// any picture?
	$picture_str = '';
	if(strstr($grade->gdescription, '<img')) {
		// find all pictures in the grade descrption
		$html = stripslashes($grade->gdescription);
		$dom = new DOMDocument;
		$dom->loadHTML($html);
		$images = array();
		foreach ($dom->getElementsByTagName('img') as $image) {
		    $src =  $image->getAttribute('src');	
		    $class = $image->getAttribute('class');
		    $images[] = array('src'=>$src, 'class'=>$class);
		} // end foreach DOM element
		
		if(sizeof($images)) {
			$target_image = $images[0]['src'];
			
			// but check if we have any that are marked with the class
			foreach($images as $image) {
				if(strstr($image['class'], 'watupro-share')) {
					$target_image = $image['src'];
					break;
				}
			}
			
			$picture_str = "&picture=".urlencode($target_image);
		}
	}   // end searching for image
	
	$twitter_options = get_option('watuproshare_twitter');
	
	// prepare tweet text
	if(!empty($twitter_options['use_twitter'])) {
		$tweet = stripslashes($twitter_options['tweet']);
		
		if(empty($tweet)) {
			$tweet = stripslashes($grade->gdescription);
			if(empty($tweet)) $tweet = stripslashes($grade->gtitle);
		}
		else {
			$tweet = str_replace('{{{grade-title}}}', stripslashes($grade->gtitle), $tweet);
			$tweet = str_replace('{{{grade-description}}}', stripslashes($grade->gdescription), $tweet);
		}
		
		$tweet = substr($tweet, 0, 140);
	}
	?>	
	<div class="watupro-share">
	 <?php if(!empty($appid)):?><a title="Share your results on Facebook" href="https://www.facebook.com/dialog/feed?app_id=<?php echo $appid?>&amp;display=popup&amp;name=<?php echo urlencode(stripslashes($grade->gtitle))?>&amp;link=<?php echo urlencode(get_permalink($_POST['post_id']))?>&amp;redirect_uri=<?php echo urlencode(get_permalink($_POST['post_id']))?>&amp;description=<?php echo urlencode(stripslashes($grade->gdescription))?><?php echo $picture_str?>" target="_blank" class="watuproshare-facebook" style="color:white;">
     Share on Facebook
   </a><?php endif;?>
   <?php if(!empty($twitter_options['use_twitter'])):?>
   <a href="https://twitter.com/share" class="twitter-share-button" data-url="<?php echo get_permalink($_POST['post_id'])?>" data-text="<?php echo htmlentities($tweet)?>" data-via="<?php echo @$twitter_options['via']?>" <?php if(!empty($twitter_options['large_button'])):?>data-size="large"<?php endif;?> <?php if(!empty($twitter_options['hashtag'])):?>data-hashtags="<?php echo $twitter_options['hashtag']?>"<?php endif;?> <?php if(empty($twitter_options['show_count'])):?>data-count="none"<?php endif;?>>Tweet</a>
<script>!function(d,s,id){var js,fjs=d.getElementsByTagName(s)[0],p=/^http:/.test(d.location)?'http':'https';if(!d.getElementById(id)){js=d.createElement(s);js.id=id;js.src=p+'://platform.twitter.com/widgets.js';fjs.parentNode.insertBefore(js,fjs);}}(document, 'script', 'twitter-wjs');</script>
   <?php endif;?>
   </div>
	<?php 
	$content = ob_get_clean();
	return $content;
}